<template>
    <div class="content-wrapper content-next-matches">

        <!--        <pre v-if="match && match.bets">-->
        <!--            {{ selectedTab.apiName }}-->
        <!--            {{ prematchBets[selectedTab.apiName.toLowerCase()] }}-->
        <!--        </pre>-->

        <loader v-if="loading"/>
        <box class="odds-table" v-if="match && !loading">
            <match-teams
                v-if="match.event"
                :teams="match.event.fixture.participants"
                :scoreboard="match.event.scoreboard"
                :startdate="match.event.fixture.start_date"
                :event-id="id"
            />

            <div v-if="watchTime"  class="watch__online_block">
                <div class="block__label">Watch Live</div>
                <div class="block__content">
                    <div v-for="(link, linkKey) in matchReferralLink" :key="linkKey" class="source__block">
                        <a :href="link" target="_blank">Stream #{{ linkKey+1 }}</a>
                    </div>
                </div>
            </div>

            <div v-if="watchTime" class="instruction__block">
                Register > Make a Deposit > Chose a Stream
            </div>

            <match-tabs :score-board-status="match.event.scoreboard" />

            <match-nav
                :nav-items="markets"
                :event-id="id"
                :route-tab="tab"
                :active="selectedTab.marketId"
            />

            <match-times
                v-if="selectedTab.marketId === 1"
                :active-type="selectedTab.marketId"
                :event-id="id"
                :match-id="id"
            />

            <match-table
                v-if="eventBets && eventBets[selectedTab.marketId]"
                :bets="eventBets[selectedTab.marketId]"
                :active-bet-type="selectedTab.apiName.toLowerCase()"
                :market-id="selectedTab.marketId"
                :event-id="id"
            />

            <match-stats
                v-if="selectedTab.marketId !== 3 && selectedTab.marketId !== 2 && eventBets && eventBets[selectedTab.marketId]"
                :bets="eventBets[selectedTab.marketId]"
                :active-bet-type="selectedTab.apiName.toLowerCase()"
                :market-id="selectedTab.marketId"
                :event-id="id"
            />
        </box>

        <match-add-to-tracker
            v-if="
                selectedTab.marketId !== 3 && selectedTab.marketId !== 2 &&
                !loading && match && match.event && id && eventBets && eventBets[selectedTab.marketId]
            "
            :event-id="id"
            :market-id="selectedTab.marketId"
            :bets="eventBets[selectedTab.marketId]"
            :active-bet-type="selectedTab.apiName.toLowerCase()"
        />
    </div>
</template>

<script>
import {mapGetters, mapActions, mapMutations} from 'vuex'
import Breadcrumbs from '../components/Breadcrumbs'
import Box from '../components/pageparts/box/Box'
import MatchTeams from '../components/pageparts/match/MatchTeams'
import MatchTabs from '../components/pageparts/match/MatchTabs'
import MatchNav from '../components/pageparts/match/MatchNav'
import MatchTimes from '../components/pageparts/match/MatchTimes'
import MatchTable from '../components/pageparts/match/MatchTable'
import MatchStats from '../components/pageparts/match/MatchStats'
import MatchAddToTracker from '../components/pageparts/match/MatchAddToTracker'
import Loader from '../components/Loader'
import moment from 'moment'

export default {
    name: 'Match',
    data() {
        return {
            markets: [
                {url: '1x2', apiName: '1X2', name: '1X2', marketId: 1},
                {url: 'ah', apiName: 'Asian Handicap', name: 'AH', marketId: 3},
                {url: 'underover', apiName: 'Under/Over', name: 'O/U', marketId: 2},
                {url: 'doublechance', apiName: 'Double Chance', name: 'DC', marketId: 7}
            ],
            loading: true,
        }
    },
    props: {
        tab: {
            type: String,
            default: '1x2'
        },
        id: {
            Type: [String, Number],
            required: true
        }
    },
    computed: {
        ...mapGetters(['match','matchReferralLink','headerClockTimezoneOffset','getMatchTabPreMatchFlag','getMatchTabGameCenterFlag','getMatchTabInPlayFlag']),
        eventBets() {

            if(this.$store.getters.getMatchTabInPlayFlag){
                return this.match.bets.inplay;
            } else return this.match.bets.prematch;
        },
        selectedTab() {
            return this.markets.filter(item => item.url.toLowerCase() === this.tab.toLowerCase())[0]
        },
        watchTime(){
            return (moment().diff( moment(this.match.event.fixture.start_date).subtract(30, 'minutes') , 'seconds') > 0) &&
                this.match.event.scoreboard && (this.match.event.scoreboard.status_id !== 3);
        }

    },
    methods: {
        ...mapActions(['fetchMatch','fetchReferralLink']),
        stopLoading() {
            this.loading = false
        },
        startLoading() {
            this.loading = true
        },
        toggleLoading() {
            this.loading = !this.loading
        },
        fetchData() {
            this.fetchMatch(this.id).finally(() => {
                this.matchLoading = false
                this.$root.$emit('setMatchName', this.match.event.fixture.participants.map(t => t.name).join(' - '));
                this.$root.$emit('setLeagueId', this.match.event.fixture.league_id);
                this.$root.$emit('setLeagueMatchName', this.match.event.fixture.name);
                this.stopLoading()
                // this.$log.debug('this.match', this.match)
            })
        },
        fetchReferral(){
            this.fetchReferralLink().finally();
        }
    },

    mounted() {
        window.Echo.channel(`jokerodds_database_presence-event-bets.${this.id}`)
            .listen('BetsUpdated', (response) => {
                console.log('to-update-', response.bets);
                this.$store.dispatch('updateBets',response.bets.prematch);
                this.$store.dispatch('updateBetsAverage',response.bets.average);
                this.$store.dispatch('updateTrackerAverage',response.bets.average);
            });

        window.Echo.channel(`jokerodds_database_presence-bets-average`)
            .listen('BetsUpdatedAverage', (response) => {
                this.$store.dispatch('updateDateMatchesTrackerAverage',response.bets);
            });
        window.Echo.channel(`jokerodds_database_presence-bets-live`)
            .listen('BetsLiveUpdated', (response) => {
                this.$store.dispatch('updateBetsLive',response.bets);
            });
    },
    watch: {
        id: function () {
            this.startLoading();
            this.fetchData()
        }
    },
    created() {
        // this.startLoading()
        this.fetchReferral();
        this.fetchData();

    },
    destroyed() {
        window.Echo.leave(`jokerodds_database_presence-bets-average`);
        window.Echo.leave(`jokerodds_database_presence-event-bets.${this.id}`)
    },
    components: {
        Loader,
        Box,
        Breadcrumbs,
        MatchTeams,
        MatchTabs,
        MatchNav,
        MatchTimes,
        MatchTable,
        MatchStats,
        MatchAddToTracker,
    },
}
</script>
